#
# Copyright 2025 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-oracle-export-incremental-finalization-strategy.json
#
# Do not edit this file manually!
#

from delphixpy.v1_11_42.web.objects.OracleExportFinalizationStrategy import OracleExportFinalizationStrategy
from delphixpy.v1_11_42 import factory
from delphixpy.v1_11_42 import common

class __Undef:
    def __repr__(self):
        return "undef"

    def __setattr__(self, name, value):
        raise Exception('Cannot modify attributes of __Undef.')

_UNDEFINED = __Undef()

class OracleExportIncrementalFinalizationStrategy(OracleExportFinalizationStrategy):
    """
    *(extends* :py:class:`v1_11_42.web.vo.OracleExportFinalizationStrategy` *)*
    The finalization strategy for Incremental V2P.
    """
    def __init__(self, undef_enabled=True):
        super().__init__()
        self._type = ("OracleExportIncrementalFinalizationStrategy", True)
        self._incremental_v2p_parameters = (self.__undef__, True)


    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super().from_dict(data, dirty, undef_enabled)
        if "incrementalV2pParameters" in data and data["incrementalV2pParameters"] is not None:
            obj._incremental_v2p_parameters = (factory.create_object(data["incrementalV2pParameters"], "OracleExportIncrementalV2pParameters"), dirty)
            factory.validate_type(obj._incremental_v2p_parameters[0], "OracleExportIncrementalV2pParameters")
        else:
            obj._incremental_v2p_parameters = (obj.__undef__, dirty)
        return obj

    def to_dict(self, dirty=False, belongs_to_parent=False):
        dct = super().to_dict(dirty, belongs_to_parent)

        def dictify(obj, prop_is_list_or_vo=False):
            if isinstance(obj, list):
                return [dictify(o, prop_is_list_or_vo) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict(dirty=dirty, belongs_to_parent=prop_is_list_or_vo)
            else:
                return obj
        if "incremental_v2p_parameters" == "type" or (self.incremental_v2p_parameters is not self.__undef__ and (not (dirty and not self._incremental_v2p_parameters[1]) or self.is_dirty_list(self.incremental_v2p_parameters, self._incremental_v2p_parameters) or belongs_to_parent)):
            dct["incrementalV2pParameters"] = dictify(self.incremental_v2p_parameters, prop_is_list_or_vo=True)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._incremental_v2p_parameters = (self._incremental_v2p_parameters[0], True)

    def is_dirty(self):
        return any([self._incremental_v2p_parameters[1]])

    def is_dirty_list(self, prop_name, private_var):
        if isinstance(prop_name, list) and prop_name and hasattr(prop_name[0], 'type'):
            for item in prop_name:
                if isinstance(item, list):
                    if self.is_dirty_list(item) or item.is_dirty():
                        return True
                elif item.is_dirty():
                    return True
        else:
            return private_var[1]
        return False

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, OracleExportIncrementalFinalizationStrategy):
            return False
        return super().__eq__(other) and \
               self.incremental_v2p_parameters == other.incremental_v2p_parameters

    def __ne__(self, other):
        return not self.__eq__(other)

    def __hash__(self):
        return id(self)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def incremental_v2p_parameters(self):
        """
        The parameters for the Incremental V2P.

        :rtype:
            :py:class:`v1_11_42.web.vo.OracleExportIncrementalV2pParameters`
        """
        return self._incremental_v2p_parameters[0]

    @incremental_v2p_parameters.setter
    def incremental_v2p_parameters(self, value):
        self._incremental_v2p_parameters = (value, True)

